// This file is generated by
//    Community Place Conductor Version 2.0 Alpha 1.
//                           Sony Corporation 1997.

import vrml.*;
import vrml.node.*;
import vrml.field.*;

public class CPSCFace extends Script {
    // Declare eventOut field(s)
    // CPC_VER_DECL begin
    private SFRotation m_outRot;
    private SFNode m_node;
    
    // CPC_VER_DECL end

    // Declare initialize()
    public void initialize() {
        // This method is called ..
        try{
            // CPC_INIT begin
            m_outRot = (SFRotation)getEventOut("outRot");
            m_node = (SFNode)getField("node");
            // CPC_INIT end
        }catch(Exception e){
            e.printStackTrace();
        }
    }
    // Declare shutdown()
    public void shutdown() {
        try{
        }catch(Exception e){
            e.printStackTrace();
        }
    }

    // CPC_HANDLER begin
    private void _inVecCB(ConstSFVec3f ev, double t) {
        // variables to use
        SFVec3f from;
        SFRotation newRot;
        float vecA[] = new float[3];
        float vecB[] = new float[3];
        float x, y, z, a, nn;
        
        Node node;
        node = (Node)m_node.getValue();
        from = (SFVec3f)node.getExposedField("translation");
        newRot = (SFRotation)node.getExposedField("rotation");
        
        // set values in vector A & B
        vecA[0] = from.getX();
        vecA[1] = from.getY();
        vecA[2] = from.getZ() - 1;
        vecB[0] = ev.getX() - from.getX();
        vecB[1] = ev.getY() - from.getY();
        vecB[2] = ev.getZ() - from.getZ();
        
        // set value in x, y, z 
        x = vecA[1]*vecB[2] - vecA[2]*vecB[1];
        y = vecA[2]*vecB[0] - vecA[0]*vecB[2];
        z = vecA[0]*vecB[1] - vecA[1]*vecB[0];
        
        // set nn
        nn = (float)Math.sqrt(x*x + y*y + z*z);
        
        // calculate the actual rotation
        x = x/nn;
        y = y/nn;
        z = z/nn;

        a = (float)Math.acos(
            (vecA[0]*vecB[0] + vecA[1]*vecB[1] + vecA[2]*vecB[2])/
               (Math.sqrt(vecA[0]*vecA[0] + vecA[1]*vecA[1] + vecA[2]*vecA[2])*
                Math.sqrt(vecB[0]*vecB[0] + vecB[1]*vecB[1] + vecB[2]*vecB[2])));
        
        newRot.setValue(x, y, z, a);
        //System.out.println(x + "\n" +  y + "\n" +  z + "\n" + a + "\n");
        m_outRot.setValue(x, y, z, a);
    }
    // CPC_HANDLER end

    // Declare processEvents field
    public void processEvents(int count, Event events[]) {
        // This method is called 
        try{
            for (int i = 0; i < count; i++) {
                // CPC_EVENT begin
                if (events[i].getName().equals("inVec"))
                    _inVecCB((ConstSFVec3f)events[i].getValue(), events[i].getTimeStamp());
                // CPC_EVENT end
            }
        }catch(Exception e){
            e.printStackTrace();
        }
    } // end of processEvents() 
} // end of class CPSCFace 
