// This file is generated by
//    Community Place Conductor Version 2.0 Alpha 1i7.
//                           Sony Corporation 1997.

import vrml.*;
import vrml.node.*;
import vrml.field.*;

public class CPSCMoveTo extends Script {
    // Declare eventOut field(s)
    // CPC_VER_DECL begin
    private SFNode m_node;
    private SFVec3f newPosition;
    private SFVec3f fromPosition;
    //private SFVec3f curPosition;
    private float[] destPosition = new float[3];
    // this is the original position of the node
    private float[] position = new float[3];
    // CPC_VER_DECL end

    // Declare initialize()
    public void initialize() {
        Node node;
        // This method is called ..
        try{
            // CPC_INIT begin

            // get reference to the node
            m_node = (SFNode)getField("node");

			// get the original position of the node
	        node = (Node)(m_node.getValue());
            fromPosition = (SFVec3f)node.getExposedField("translation");
			position[0] = fromPosition.getX();
			position[1] = fromPosition.getY();
			position[2] = fromPosition.getZ();

            // initialize destination
			for (int i=0; i<3; i++){
				// current destination is set to the original position
				destPosition[i] = position[i];
			}

            // CPC_INIT end
        }catch(Exception e){
            e.printStackTrace();
        }
    }
    // Declare shutdown()
    public void shutdown() {
        try{
        }catch(Exception e){
            e.printStackTrace();
        }
    }

    // CPC_HANDLER begin
    private void _fractionCB(ConstSFFloat ev, double t) {
        Node node;
        node = (Node)(m_node.getValue());
        float frac = ev.getValue();
        // if new destination is set
        if (destPosition[0] != position[0] || destPosition[1] != position[1]
        	|| destPosition[2] != position[2]){
	        newPosition = (SFVec3f)node.getExposedField("translation");
    	    newPosition.setValue(
    	    	position[0]+(destPosition[0]-position[0])*frac, 
    	    	position[1]+(destPosition[1]-position[1])*frac, 
    	    	position[2]+(destPosition[2]-position[2])*frac);
    	}
     }

     private void _positionCB(ConstSFVec3f ev, double t) {
		// set new destination position
		destPosition[0] = ev.getX();
		destPosition[1] = ev.getY();
		destPosition[2] = ev.getZ();
	}
	
	
    // CPC_HANDLER end

    // Declare processEvents field
    public void processEvents(int count, Event events[]) {
        // This method is called 
        try{
            for (int i = 0; i < count; i++) {
                // CPC_EVENT begin
                if (events[i].getName().equals("fraction"))
                    _fractionCB((ConstSFFloat)events[i].getValue(), events[i].getTimeStamp());
                if (events[i].getName().equals("position"))
                	_positionCB((ConstSFVec3f)events[i].getValue(), events[i].getTimeStamp());
                // CPC_EVENT end
            }
        }catch(Exception e){
            e.printStackTrace();
        }
    } // end of processEvents() 
} // end of class CPSCMoveTo 
