// This file is generated by
//    Community Place Conductor Version 2.0 Alpha 1.
//                           Sony Corporation 1997.

import vrml.*;
import vrml.node.*;
import vrml.field.*;

public class CPSCRotateTo extends Script {
    // Declare eventOut field(s)
    // CPC_VER_DECL begin
    private SFNode m_node;
    private SFRotation orientation;
    private float ori[] = new float[4];
    private float to[] = new float[4];
    // CPC_VER_DECL end

    // Declare initialize()
    public void initialize() {
        // This method is called ..
        try{
            // CPC_INIT begin
            // get reference to the node
            m_node = (SFNode)getField("node");

			// get the original orientation of the node
			Node node;
	        node = (Node)(m_node.getValue());
            orientation = (SFRotation)node.getExposedField("rotation");
			orientation.getValue(ori);

			// initialize orientation to current orientation
			for (int i=0; i<4; i++){
				to[i] = ori[i];
			}
			
            // CPC_INIT end
        }catch(Exception e){
            e.printStackTrace();
        }
    }
    // Declare shutdown()
    public void shutdown() {
        try{
        }catch(Exception e){
            e.printStackTrace();
        }
    }

    // CPC_HANDLER begin
    private void _orientationCB(ConstSFRotation ev, double t) {
		// set new orientation
		ev.getValue(to);
    }
    private void _fractionCB(ConstSFFloat ev, double t) {
		float frac = ev.getValue();
        // if new orientation is set
        if (to[0] != ori[0] || to[1] != ori[1] || 
        	to[2] != ori[2] || to[3] != ori[3]){
			ori[0] = to[0];
			ori[1] = to[1];
			ori[2] = to[2];
			ori[3] = ori[3] + (to[3] - ori[3]) * frac;
    	    orientation.setValue(ori);
    	}
    }
    // CPC_HANDLER end

    // Declare processEvents field
    public void processEvents(int count, Event events[]) {
        // This method is called 
        try{
            for (int i = 0; i < count; i++) {
                // CPC_EVENT begin
                if (events[i].getName().equals("orientation"))
                    _orientationCB((ConstSFRotation)events[i].getValue(), events[i].getTimeStamp());
            if (events[i].getName().equals("fraction"))
            	_fractionCB((ConstSFFloat)events[i].getValue(), events[i].getTimeStamp());
                // CPC_EVENT end
            }
        }catch(Exception e){
            e.printStackTrace();
        }
    } // end of processEvents() 
} // end of class CPSCRotateTo 
